package com.urbandroid.sleep.captchapack.flags;

import android.os.Bundle;

import com.urbandroid.sleep.captchapack.BaseCaptcha;
import com.urbandroid.sleep.captchapack.R;

public class FunWithFlagsCaptcha extends BaseCaptcha {

    private QuizSession session;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.flags);

        if (savedInstanceState != null) {
            session = QuizSession.restore(this, savedInstanceState);
        }
        if (session == null) {
            session = new QuizSession(this);
            session.generateNext();
        }
        session.show();
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        if (session != null) {
            session.save(outState);
        }
        super.onSaveInstanceState(outState);
    }

}
